//Chris Eng & Ken Rice
//CSS450 Sung

// Blob.h
#pragma once

#define GO_UP 1
#define GO_DOWN 2
#define GO_RIGHT 3
#define GO_LEFT 4

enum eBlobState {bGUARDING, bHUNTING, bWANDERING, bRETURNING };

class CBlob : public UWB_SceneNode {
public:
	CBlob(const wchar_t* name = L"Blob");
	~CBlob();

	void DoMove(const UWB_BoundingVolume* targetBound, vec3 itemCenter, float difficulty);	
	vec3 CheckHeroCollision(const UWB_BoundingVolume* otherBound, const vec3 otherTranslation);
	int GetStunned() const;
	void SetStunned(int stunTimer);
	void SetWhichWallHit(int wall);

private:
	float GetDistance(vec3 start, vec3 end);
	vec3 GetCenterInWC();
	void DoStateMachine(const UWB_BoundingVolume* targetBound, vec3 itemCenter);
	void WalkForwards(float rotation, float speed);
	void DoHunting(const UWB_BoundingVolume* targetBound);
	void DoWandering();
	void DoGuarding(vec3 itemCenter);
	void DoReturning(vec3 itemCenter);
	void AlternateTexture(int index);

	UWB_PrimitiveList *m_pBodyComponents;
	float m_timer;
	float m_difficulty;
	eBlobState m_state;
	int m_stunTimer;
	float m_rotation;
	int m_textureState;
	bool m_stateDirectionDown;
	int m_direction;
	float m_moveTimer;

	int m_leftWallCnt;
	int m_rightWallCnt;
	int m_downWallCnt;
	int m_upWallCnt;
};