//Chris Eng & Ken Rice

#pragma once

//#define DARKNESS_REVEAL_RANGE 17.0f
#define FAST_FADE 0.01f
#define NORMAL_FADE 0.001f
#define SLOW_FADE 0.0005f

class CDarknessGrid : public UWB_SceneNode {

public:

	//Default constructor to appease the compiler
	CDarknessGrid(const wchar_t* name = L"Darkness");

	//MUST CALL THIS TO USE DARKNESS GRID
	void Initialize(int rows, int cols, float levelWidth, float levelHeight, float levelScale, float fadeRate);

	void RevealTile(const UWB_BoundingVolume* otherBound);
	void TransformShroudFrame(const vec3 newTranslation, const float newRotationRadians);

	//0: darkest 1: dark 2: bright 3: brightest
	int GetDarknessLevel();

	//0: cellPhone 1:flashlight normal 2: flashlight high
	void SetDarknessLevel(int level);
	//void SetDarknessLevel(eEquipmentType currentEquipped);
	//void SetDarknessLevel(int level);
	void SetTileFadeRate(float newRate);

	void Draw( eLevelOfDetail lod, UWB_DrawHelper& draw_helper, bool drawDarkFrame ) const;

protected:

	//Leave wedgeRadians as NULL if you want to make a Circle!
	void MakeShroudFrame(vec3 center, float radius, float wedgeRadians, UWB_Color edgeColor, UWB_PrimitiveList* gradientCollection);

	//The dark tiles covering the map
	UWB_PrimitiveRectangleXY* m_DarknessTiles;
	float* m_TileLife;
	float m_TileFadeRate;

	int m_Rows;
	int m_Cols;
	float m_TileWidth;
	float m_TileHeight;
	float m_LevelScale;

	static const int GOOD_TILE_RANGE = 2;
};
