//Chris Eng & Ken Rice
//CSS450 Sung

//Shroud.h

#pragma once

#define FAST_FADE 0.01f
#define NORMAL_FADE 0.001f
#define SLOW_FADE 0.0005f

class CShroud : public UWB_SceneNode {

public:
	
	void Initialize(int rows, int cols, float width, float height, float levelScale, float fadeRate, UWB_Color shroudColor);

	void RevealTile(const UWB_BoundingVolume* otherBound);
	void TransformShroudFrame(const vec3 newTranslation, const float newRotationRadians);

	void SetShroudColor(UWB_Color newColor);
	void SetShroudIntensity(int newLevel);
	int GetShroudIntensity();

	float GetShroudFrameRadius() const;
	float GetHighBeamGap() const;

	void SetTileFadeRate(float newRate);

	void Draw( eLevelOfDetail lod, UWB_DrawHelper& draw_helper, bool drawShroudFrame, bool drawShroudTiles ) const;

protected:

	//Leave wedgeRadians as NULL if you want to make a Circle!
	void MakeShroudFrame(vec3 center, float radius, float wedgeRadians, UWB_Color edgeColor, UWB_PrimitiveList* gradientCollection);

	//The dark tiles covering the map
	UWB_PrimitiveRectangleXY* m_DarknessTiles;
	float* m_TileLife;
	float m_TileFadeRate;

	int m_Rows;
	int m_Cols;
	float m_TileWidth;
	float m_TileHeight;
	float m_LevelScale;

	UWB_Color m_ShroudColor;
	
	float GOOD_FRAME_RADIUS; //should be around 19.25f
	int GOOD_TILE_RANGE; //= 1;
};
