//Chris Eng & Ken Rice
//CSS450 Sung

// EscapeProjectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EscapeProject.h"
#include "EscapeProjectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CEscapeProjectDlg dialog
CEscapeProjectDlg::CEscapeProjectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEscapeProjectDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEscapeProjectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_REDKEY, m_RedKey);
	DDX_Control(pDX, IDC_BLUEKEY, m_BlueKey);
	DDX_Control(pDX, IDC_GREENKEY, m_GreenKey);
	DDX_Control(pDX, IDC_YELLOWKEY, m_YellowKey);
	DDX_Control(pDX, IDC_BUTTON_BATTERY, m_Battery);
	DDX_Control(pDX, IDC_PROGRESS_BATTERY, m_BatteryBar);
	DDX_Control(pDX, IDC_PROGRESS_HEALTH, m_HealthBar);
	DDX_Control(pDX, IDC_BUTTON_HEALTH, m_ButtonHealth);
}

BEGIN_MESSAGE_MAP(CEscapeProjectDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_CONTROLS, &CEscapeProjectDlg::OnBnClickedButtonControls)
	ON_BN_CLICKED(IDC_BUTTON_OPTIONS, &CEscapeProjectDlg::OnBnClickedButtonOptions)
	ON_BN_CLICKED(IDC_BUTTON_NEWGAME, &CEscapeProjectDlg::OnBnClickedButtonNewgame)
END_MESSAGE_MAP()


// CEscapeProjectDlg message handlers

BOOL CEscapeProjectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//Enable keyboard input from user
	m_KeyboardHandler.Initialize( this->m_hWnd );

	//Initialize D3D
	if (!UWBD3D_GraphicsSystem::GetSystem().CreateGraphicsContext(m_hWnd))
		return false;

	//Attatch the big view/controller into its placeholder
	if (!m_LargeView.Initialize(*this, IDC_PLACEHOLDER_VIEW_LARGE))
		return false;
	
	//Attatch the small view/controller into its placeholder
	if (!m_SmallView.Initialize(*this, IDC_PLACEHOLDER_VIEW_SMALL))
		return false;

	//Set the views to envelop certain ranges of the canvas, then join the small
	//view into the large, resulting in an automatic "small view" box inside the large
	UWB_BoundingBox StartingWindow(vec3(-20.0f, -20.0f, 0.0f), vec3(20.0f, 20.0f, 0.0f));
	m_LargeView.SetWCWindow(StartingWindow);
	CenterLargeViewOnHero();
	m_SmallView.SetWCWindow(theApp.GetModel().GetWorldBounds()); //Bounds are set by calling GetWorldBounds, conveniently :)
	m_SmallView.SetLinkedHandler(&m_LargeView);

	//Setup the timer to maintain a framerate
	int msInterval = 25; // timer fires every 25 ms.
	SetTimer(0, msInterval, NULL);    // our goal is to approx 40 frames per second

	//Attatch a UWB_hEchoWindow to the debug area. This object allows
	//the dialog AND view/controller to echo to the status area.
	//CWnd* pWnd = GetDlgItem(IDC_PLACEHOLDER_ECHO_DEBUG);
	//if(pWnd)
	//	UWB_hEchoWindow = pWnd->m_hWnd;

	pauseKeyWasDown = cellKeyWasDown = flashlightKeyWasDown = false;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_RedKey.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_REDKEY)));
	m_RedKey.ShowWindow(SW_HIDE);
	m_BlueKey.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BLUEKEY)));
	m_BlueKey.ShowWindow(SW_HIDE);
	m_GreenKey.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_GREENKEY)));
	m_GreenKey.ShowWindow(SW_HIDE);
	m_YellowKey.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_YELLOWKEY)));
	m_YellowKey.ShowWindow(SW_HIDE);

	//Setup the battery icon GUI
	m_Battery.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BATTERY_GUI)));
	m_Battery.ShowWindow(SW_SHOW);

	//Setup the health icon GUI
	m_ButtonHealth.SetBitmap(::LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_HEALTH_GUI)));
	m_ButtonHealth.ShowWindow(SW_SHOW);

	//Setup the battery life bar
	m_BatteryBar.SetRange(0, theApp.GetModel().GetBatteryLife());
	m_BatteryBar.SetPos(theApp.GetModel().GetBatteryLife());

	//Setup the hero health bar
	m_HealthBar.SetRange(0, theApp.GetModel().GetHealth());
	m_HealthBar.SetPos(theApp.GetModel().GetHealth());

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEscapeProjectDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEscapeProjectDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CEscapeProjectDlg::OnTimer(UINT nIDEvent) {

	//Note: enforcing pause state here in the controller

	//Check the keyboard for user input
	HandleKeyboardInput();

	if(theApp.GetModel().GetPauseState() == false) {
		
		//Check if a new level was started
		bool newLevel = theApp.GetModel().GetIsNewLevelCreated();
		if(newLevel) {
			//Readjust the small view
			m_SmallView.SetWCWindow(theApp.GetModel().GetWorldBounds());
			
			//Move the large view to the hero
			CenterLargeViewOnHero();
		}
		
		//Update the model
		theApp.GetModel().UpdateModel();

		//Draw the model
		m_LargeView.DrawGraphics();
		m_SmallView.DrawGraphics();
	
		//Update the key groupbox
		if(theApp.GetModel().HeroHasRedKey()) {
			m_RedKey.ShowWindow(SW_SHOW);
		} else {
			m_RedKey.ShowWindow(SW_HIDE);
		}
		if(theApp.GetModel().HeroHasBlueKey()) {
			m_BlueKey.ShowWindow(SW_SHOW);
		} else {
			m_BlueKey.ShowWindow(SW_HIDE);
		}
		if(theApp.GetModel().HeroHasGreenKey()) {
			m_GreenKey.ShowWindow(SW_SHOW);
		} else {
			m_GreenKey.ShowWindow(SW_HIDE);
		}
		if(theApp.GetModel().HeroHasYellowKey()) {
			m_YellowKey.ShowWindow(SW_SHOW);
		} else {
			m_YellowKey.ShowWindow(SW_HIDE);
		}

		//Update the battery life bar
		m_BatteryBar.SetPos(theApp.GetModel().GetBatteryLife());

		//Update the hero's health bar
		m_HealthBar.SetPos(theApp.GetModel().GetHealth());
	}
}

void CEscapeProjectDlg::HandleKeyboardInput() {
	
	//Useful for helping the hero know when to shuffle his shoes
	bool isHeroWalking = false;

	bool isPaused = theApp.GetModel().GetPauseState();

	//Poll the keyboard for input
	m_KeyboardHandler.PollKeyboardState();

	//Check for pause command
	if( m_KeyboardHandler.KeyDown( DIK_P ) ) {
		pauseKeyWasDown = true;
	} else if( m_KeyboardHandler.KeyUp( DIK_P ) ) {
		if( pauseKeyWasDown ) {
			isPaused = !isPaused;
			theApp.GetModel().SetPauseState(isPaused);
			pauseKeyWasDown = false;
		}
	}
	if(isPaused) {
		CString pauseMsg;
		pauseMsg.Format(L"Paused!");
		UWB_EchoToStatusArea(pauseMsg);
		return;
	}

	//Hero rotation key checks
	if( m_KeyboardHandler.KeyDown( DIK_LEFT ) ) {
		theApp.GetModel().HeroRotateCCW();
		isHeroWalking = true;
		CenterLargeViewOnHero();
	} else if( m_KeyboardHandler.KeyDown( DIK_RIGHT ) ) {
		theApp.GetModel().HeroRotateCW();
		isHeroWalking = true;
		CenterLargeViewOnHero();
	}

	//Hero step key checks
	if( m_KeyboardHandler.KeyDown( DIK_UP ) ) {
		theApp.GetModel().HeroStepForward();
		isHeroWalking = true;
		CenterLargeViewOnHero();
	} else if( m_KeyboardHandler.KeyDown( DIK_DOWN ) ) {
		theApp.GetModel().HeroStepBackward();
		isHeroWalking = true;
		CenterLargeViewOnHero();
	}

	//Equip key checks
	//Since these keys are tied with accompanying sounds, make sure to only
	//call the equip functions when the key is released, not if being held.
	if(m_KeyboardHandler.KeyDown( DIK_X ) ) {
		flashlightKeyWasDown = true;
	} else if (m_KeyboardHandler.KeyUp( DIK_X ) ) {
		if (flashlightKeyWasDown) {
			theApp.GetModel().HeroEquipFlashlight();
			CenterLargeViewOnHero();
			flashlightKeyWasDown = false;
		}
	} 
	if (m_KeyboardHandler.KeyDown( DIK_Z ) ) {
		cellKeyWasDown = true;
	} else if (m_KeyboardHandler.KeyUp( DIK_Z ) ) {
		if (cellKeyWasDown) {
			theApp.GetModel().HeroEquipCellPhone();
			CenterLargeViewOnHero();
			cellKeyWasDown = false;
		}
	}

	//Inform the model->hero that he/she is walking during this update
	theApp.GetModel().HeroIsWalking(isHeroWalking);
}
void CEscapeProjectDlg::OnBnClickedButtonControls() {
	
	//Pause the game for the player
	theApp.GetModel().SetPauseState(true);

	CControlsDialog dlg;
	dlg.DoModal();

	theApp.GetModel().SetPauseState(false);
}

void CEscapeProjectDlg::OnBnClickedButtonOptions()
{
	//Pause the game for the player
	theApp.GetModel().SetPauseState(true);

	COptionDialog dlg;
	dlg.DoModal();

	theApp.GetModel().SetPauseState(false);
}

void CEscapeProjectDlg::OnBnClickedButtonNewgame()
{
	theApp.GetModel().Initialize(1);
}

void CEscapeProjectDlg::CenterLargeViewOnHero() {
	
	UWB_XformInfo heroXform = theApp.GetModel().GetHeroXform();
	UWB_BoundingBox zoomWindow = m_LargeView.GetWCWindow();
	zoomWindow.MoveCenterTo(heroXform.GetTranslation());
	m_LargeView.SetWCWindow(zoomWindow);

	UWB_XformInfo equipmentXform = theApp.GetModel().GetEquipmentXform();
	theApp.GetModel().TransformShroudFrame(equipmentXform.GetTranslation(), equipmentXform.GetRotationInRadians());
	
	m_LargeView.SetCurrentlyMouseScrolling(false);
}
