//Chris Eng & Ken Rice
//CSS450 Sung

// EscapeProjectDlg.h : header file
//

#pragma once
#include "KeyboardHandler.h"
#include "DrawAndMouseHandler.h"
#include "ControlsDialog.h"
#include "OptionDialog.h"
#include "afxwin.h"
#include "afxcmn.h"

// CEscapeProjectDlg dialog
class CEscapeProjectDlg : public CDialog
{
// Construction
public:
	CEscapeProjectDlg(CWnd* pParent = NULL);	// standard constructor

	afx_msg void OnBnClickedButtonControls();
	afx_msg void OnBnClickedButtonOptions();
	afx_msg void OnBnClickedButtonNewgame();

// Dialog Data
	enum { IDD = IDD_ESCAPEPROJECT_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_MESSAGE_MAP()

	//test
	bool pauseKeyWasDown;
	bool cellKeyWasDown;
	bool flashlightKeyWasDown;

	//Dialog for listing game controls
	CControlsDialog* pControlsDlg;
	//Dialog for listing options
	COptionDialog* pOptionDlg;

	CKeyboardHandler m_KeyboardHandler;
	CDrawOnlyHandler m_LargeView;
	CMainHandler m_SmallView;

	//Helper for keyboard checking routine
	void HandleKeyboardInput();

private:
	CButton m_RedKey;
	CButton m_BlueKey;
	CButton m_GreenKey;
	CButton m_YellowKey;
	CButton m_Battery;
	
	// //Battery life bar via add member variable wizard
	CProgressCtrl m_BatteryBar;

	//Helper function, called when a directional key is pressed
	void CenterLargeViewOnHero();
	CProgressCtrl m_HealthBar;
	// //Chris'
	CButton m_ButtonHealth;

};
