//Chris Eng & Ken Rice
//CSS450 Sung

// Ghost.h
#pragma once
#include "CLevel.h"

enum eGhostState {gGUARDING, gHUNTING, gWANDERING, gRETURNING };

class CGhost : public UWB_SceneNode {
public:
	CGhost(const wchar_t* name = L"Ghost");
	~CGhost();

	void DoMove(const UWB_BoundingVolume* targetBound, vec3 itemCenter, float difficulty);
	void SetItemOrder(eItemType key1, eItemType key2, eItemType key3, eItemType key4);
	eItemType GetItemGuarding();
	void IncrementItemGuarding(); 
	int GetStunned() const;
	void SetStunned(int stunTimer);

private:
	float GetDistance(vec3 start, vec3 end);
	vec3 GetCenterInWC();
	void WalkForwards(float rotation);
	void DoWandering();
	void DoHunting(const UWB_BoundingVolume* targetBound);
	void DoGuarding(vec3 itemCenter);
	void DoReturning(vec3 itemCenter);
	void DoStateMachine(const UWB_BoundingVolume* targetBound, vec3 itemCenter);
	
	UWB_PrimitiveList *m_pBodyComponents;
	float m_rotation;
	float m_timer;
	int m_direction;
	eGhostState m_state;	
	float m_difficulty;
	int m_stunTimer;

	eItemType m_guarding;
	eItemType m_key1; 
	eItemType m_key2; 
	eItemType m_key3; 
	eItemType m_key4;
};