//Chris Eng & Ken Rice
//CSS450 Sung

//With references from Sung & Baer's CArm class
//Human.cpp

#include "stdafx.h"
#include "Human.h"

CHuman::CHuman(/*vec3 at,*/ const wchar_t* name) : UWB_SceneNode(name) {

	UWB_PrimitiveList *pHeadComponents = new UWB_PrimitiveList();
	UWB_PrimitiveList *pBodyComponents = new UWB_PrimitiveList();
	UWB_PrimitiveList *pLeftArmComponents  = new UWB_PrimitiveList();
	UWB_PrimitiveList *pLeftHandComponents = new UWB_PrimitiveList();
	UWB_PrimitiveList *pLegComponents = new UWB_PrimitiveList();
	UWB_PrimitiveList *pRightArmComponents = new UWB_PrimitiveList(); //Note: this includes the right hand!

	//The body
	UWB_PrimitiveRectangleXY* pBody = new UWB_PrimitiveRectangleXY();
	pBody->SetCorners( vec3(-3,-5,0), vec3(3,5,0) );
	pBody->SetFlatColor( UWB_Color( 50,50,255));
	pBody->SetShadeMode( smFlat );
	pBodyComponents->Append( pBody );

	//Left shoulder (part of body, not arm)
	UWB_PrimitiveCircle* pLeftShoulder = new UWB_PrimitiveCircle();
	pLeftShoulder->SetCenter(0,5);
	pLeftShoulder->SetRadius(3.0f);
	pLeftShoulder->SetFlatColor(UWB_Color(50,50,255));
	pLeftShoulder->SetShadeMode(smFlat);
	pBodyComponents->Append( pLeftShoulder );

	//Right shoulder (part of body, not arm)
	UWB_PrimitiveCircle* pRightShoulder = new UWB_PrimitiveCircle();
	pRightShoulder->SetCenter(0,-5);
	pRightShoulder->SetRadius(3.0f);
	pRightShoulder->SetFlatColor(UWB_Color(50,50,255));
	pRightShoulder->SetShadeMode(smFlat);
	pBodyComponents->Append( pRightShoulder );

	//The Head
	UWB_PrimitiveCircle* pHead = new UWB_PrimitiveCircle();
	pHead->SetCenter(0,0);
	pHead->SetRadius(5.0f);
	pHead->SetFlatColor(UWB_Color(0.93f,0.72f,0.38f,100.0f));
	pHead->SetShadeMode(smFlat);
	pHeadComponents->Append(pHead);

	//LEFT EYE
	UWB_PrimitiveCircle* pLeftEye = new UWB_PrimitiveCircle();
	pLeftEye->SetCenter(3,2);
	pLeftEye->SetRadius(1.0f);
	pLeftEye->SetFlatColor(UWB_Color(1.0f, 1.0f, 1.0f, 100.0f));
	pLeftEye->SetShadeMode(smFlat);
	pHeadComponents->Append(pLeftEye);

	//LEFT PUPIL
	UWB_PrimitiveCircle* pLeftPupil = new UWB_PrimitiveCircle();
	pLeftPupil->SetCenter(3.5,2);
	pLeftPupil->SetRadius(0.5f);
	pLeftPupil->SetFlatColor(UWB_Color(0.33f, 0.72f, 0.33f, 100.0f));
	pLeftPupil->SetShadeMode(smFlat);  
	pHeadComponents->Append(pLeftPupil);

	//RIGHT EYE
	UWB_PrimitiveCircle* pRightEye = new UWB_PrimitiveCircle();
	pRightEye->SetCenter(3,-2);
	pRightEye->SetRadius(1.0f);
	pRightEye->SetFlatColor(UWB_Color(1.0f, 1.0f, 1.0f, 100.0f));
	pRightEye->SetShadeMode(smFlat);
	pHeadComponents->Append(pRightEye);
	  
	//RIGHT PUPIL
	UWB_PrimitiveCircle* pRightPupil = new UWB_PrimitiveCircle();
	pRightPupil->SetCenter(3.5,-2);
	pRightPupil->SetRadius(0.5f);
	pRightPupil->SetFlatColor(UWB_Color(0.33f, 0.72f, 0.33f, 100.0f));
	pRightPupil->SetShadeMode(smFlat);
	pHeadComponents->Append(pRightPupil);

	//NOSE
	UWB_PrimitiveRectangleXY* pNose = new UWB_PrimitiveRectangleXY();
	pNose->SetCorners( vec3(4,-1,0), vec3(6,1,0) );
	pNose->SetFlatColor( UWB_Color(0.93f,0.72f,0.38f,100.0f));
	pNose->SetShadeMode( smFlat );
	pHeadComponents->Append(pNose);

	//Left Arm
	UWB_PrimitiveRectangleXY* pLeftArm = new UWB_PrimitiveRectangleXY();
	pLeftArm->SetCorners( vec3(0, 5, 0), vec3(8, 8, 0));
	pLeftArm->SetFlatColor( UWB_Color(0.93f,0.72f,0.38f,100.0f));
	pLeftArm->SetShadeMode( smFlat );
	pLeftArmComponents->Append(pLeftArm);

	//Left Sleeve (part of the arm, not the body)
	UWB_PrimitiveRectangleXY* pLeftSleeve = new UWB_PrimitiveRectangleXY();
	pLeftSleeve->SetCorners(vec3(0.0f, 4.8f, 0.0f), vec3(3.5f, 8.0f, 0.0f)); //a little crazy
	pLeftSleeve->SetFlatColor( UWB_Color(50,50,200) ); //slightly darker than the shirt
	pLeftSleeve->SetShadeMode( smFlat );
	pLeftArmComponents->Append(pLeftSleeve);

	//Flashlight is our "net" that we wish to catch bullets with
	UWB_PrimitiveRectangleXY* pFlashlight = new UWB_PrimitiveRectangleXY();
	pFlashlight->SetCorners( vec3(8, 5, 0), vec3(14, 8, 0));
	pFlashlight->SetFlatColor( UWB_Color(0.0f,0.0f,0.0f,0.0f));
	pFlashlight->SetShadeMode( smFlat );
	pFlashlight->EnableTexturing(true);
	pFlashlight->EnableBlending(true);
	//From Joe O'Leary at http://www.codeguru.com/forum/archive/index.php/t-48667.html
	wchar_t* wstr_File = L"Texture/Flashlight.png";
	pFlashlight->SetTextureFileName(wstr_File);
	pLeftHandComponents->Append(pFlashlight);

	//Set a pointer to the "tool primitive" for faster texture swapping
	pTool = pFlashlight;
	currentlyHolding = FLASHLIGHT_NORMAL;

	//Left Hand
	UWB_PrimitiveCircle* pLeftHand = new UWB_PrimitiveCircle();
	pLeftHand->SetCenter(8.0f, 6.5f);
	pLeftHand->SetRadius(2.0f);
	pLeftHand->SetFlatColor( UWB_Color(0.93f,0.72f,0.38f,100.0f));
	pLeftHand->SetShadeMode( smFlat );
	pLeftHandComponents->Append(pLeftHand);

	//Left Leg
	UWB_PrimitiveRectangleXY* pLeftLeg = new UWB_PrimitiveRectangleXY();
	pLeftLeg->SetCorners(vec3(-3.0f, 2.0f, 0.0f), vec3(3.0f, 5.0f, 0.0f));
	pLeftLeg->SetFlatColor( UWB_Color(0.40f, 0.50f, 0.40f) );
	pLeftLeg->SetShadeMode( smFlat );
	pLegComponents->Append(pLeftLeg);

	//Right Leg
	UWB_PrimitiveRectangleXY* pRightLeg = new UWB_PrimitiveRectangleXY();
	pRightLeg->SetCorners(vec3(-3.0f, -2.0f, 0.0f), vec3(3.0f, -5.0f, 0.0f));
	pRightLeg->SetFlatColor( UWB_Color(0.40f, 0.50f, 0.40f) );
	pRightLeg->SetShadeMode( smFlat );
	pLegComponents->Append(pRightLeg);

	//Right hand
	UWB_PrimitiveCircle* pRightHand = new UWB_PrimitiveCircle();
	pRightHand->SetCenter(0.0f, -6.5f, 0.0f);
	pRightHand->SetRadius(1.5f); //slightly smaller than the left hand
	pRightHand->SetFlatColor( UWB_Color(UWB_Color(0.93f,0.72f,0.38f,100.0f) ) );
	pRightHand->SetShadeMode( smFlat );
	pRightArmComponents->Append(pRightHand);

	//Attatch the head components as the primitive of a head SceneNode
	UWB_SceneNode* pHeadNode = new UWB_SceneNode(L"Head");
	pHeadNode->SetPrimitive(pHeadComponents);

	//Attatch the body components as the primitive of a body SceneNode
	UWB_SceneNode* pBodyNode = new UWB_SceneNode(L"Body");
	pBodyNode->SetPrimitive(pBodyComponents);
		
	//Attatch the left hand components as the primitive of a left hand SceneNode
	UWB_SceneNode* pLeftHandNode  = new UWB_SceneNode(L"Left Hand");
	pLeftHandNode->SetPrimitive(pLeftHandComponents);

	//Attatch the left arm components as the primitive of a left arm SceneNode
	UWB_SceneNode* pLeftArmNode = new UWB_SceneNode(L"Left Arm");
	pLeftArmNode->SetPrimitive(pLeftArmComponents);

	//Attatch the left hand as a child of the left arm
	pLeftArmNode->InsertChildNode(pLeftHandNode);

	//Attatch the leg components as the primitive of a leg SceneNode
	UWB_SceneNode* pLegNode = new UWB_SceneNode(L"Legs");
	pLegNode->SetPrimitive(pLegComponents);

	//Attatch the right arm & right hand components as the primitive of a right arm SceneNode
	UWB_SceneNode* pRightArmNode = new UWB_SceneNode(L"Right Arm");
	pRightArmNode->SetPrimitive(pRightArmComponents);

	//Attatch all SceneNodes to the Hero SceneNode
	InsertChildNode(pLegNode);		//GetChildNode( 0 )
	InsertChildNode(pLeftArmNode);	//GetChildNode( 1 )
	InsertChildNode(pRightArmNode);	//GetChildNode( 2 )
	InsertChildNode(pBodyNode);		//GetChildNode( 3 )
	InsertChildNode(pHeadNode);		//GetChildNode( 4 )

	frame_Equip = -1; //"Not activated"
	frame_Walk = 0;	  //"Shoes under body"
	frame_Look = 0;	  //"Straight ahead"
	
	SetIsWalking(false);
	SetInvincibleTimer(0);
}

void CHuman::StepForward() {
	float rotation = m_xform.GetRotationInRadians();

	float xComponent = cos(rotation) * STEP_FORWARD_INCREMENT;
	float yComponent = sin(rotation) * STEP_FORWARD_INCREMENT;

	vec3 translation = m_xform.GetTranslation();
	m_xform.SetTranslation(vec3(translation.x + xComponent, translation.y + yComponent, 0.0f));
}

void CHuman::StepBackward() {
	float rotation = m_xform.GetRotationInRadians();

	float xComponent = -cos(rotation) * STEP_BACKWARD_INCREMENT;
	float yComponent = -sin(rotation) * STEP_BACKWARD_INCREMENT;

	vec3 translation = m_xform.GetTranslation();
	m_xform.SetTranslation(vec3(translation.x + xComponent, translation.y + yComponent, 0.0f));
}

void CHuman::RotateCCW() {
	float rotation = m_xform.GetRotationInRadians();

	rotation = rotation + (ROTATION_INCREMENT * UWB_PI / 180);
	KeepRadiansInBounds(rotation);

	m_xform.SetRotationRadians(rotation);
}

void CHuman::RotateCW() {
	float rotation = m_xform.GetRotationInRadians();

	rotation = rotation - (ROTATION_INCREMENT * UWB_PI / 180);
	KeepRadiansInBounds(rotation);
	
	m_xform.SetRotationRadians(rotation);
}

void CHuman::EquipFlashlight() {
	if(currentlyHolding == CELLPHONE && frame_Equip == ANIMATION_READY) {
		pTool->SetTextureFileName(L"Texture/Flashlight.png");
		currentlyHolding = FLASHLIGHT_NORMAL;
		frame_Equip = ANIMATION_GO;
	}
}

void CHuman::EquipCellPhone() {
	if(currentlyHolding != CELLPHONE && frame_Equip == ANIMATION_READY) {
		pTool->SetTextureFileName(L"Texture/CellPhone.png");
		currentlyHolding = CELLPHONE;
		frame_Equip = ANIMATION_GO;
	}
}

void CHuman::ToggleFlashlightMode() {
	
	if(currentlyHolding == FLASHLIGHT_NORMAL) {
		currentlyHolding = FLASHLIGHT_HIGH;
	} else {
		currentlyHolding = FLASHLIGHT_NORMAL;
	}
}

void CHuman::SetIsWalking(bool flag) {
	isWalking = flag;
}

void CHuman::Animate() {
	//Check if the equip animation is needed
	AnimationEquip();

	//Check if the walk animation is needed
	AnimationWalk();

	//The human constantly looks around
	AnimationLook();

	//Update the invicibility timer if needed
	SetInvincibleTimer(GetInvincibleTimer() - 1);
}

void CHuman::AnimationEquip() {
	//if this is the first frame of the animation
	if ( frame_Equip == ANIMATION_GO ) {
		//Displace the arm 
		UWB_SceneNode* pArm = GetChildNode(1);
		UWB_XformInfo xFormArm = pArm->GetXformInfo();
		float rotationArm = xFormArm.GetRotationInDegrees();
		xFormArm.SetPivot( vec3(0, 5, 0) ); //hard code, "pivot at armpit"
		rotationArm -= ARM_DISPLACEMENT - ARM_ROTATE_INCREMENT; //shrink the initial displacement (45deg) by one frame's worth of rotation since frame 0 counts
		xFormArm.SetRotationDegrees(rotationArm);
		pArm->SetXformInfo(xFormArm);

		//Displace the hand
		UWB_SceneNode* pHand = pArm->GetChildNode(0);
		UWB_XformInfo xFormHand = pHand->GetXformInfo();
		xFormHand.SetPivot(vec3(8, 6.5, 0)); //hard code, "pivot at palm"
		float rotationHand = xFormHand.GetRotationInDegrees();
		rotationHand -= 2 * ARM_DISPLACEMENT - HAND_ROTATE_INCREMENT; //shrink the initial displacement (90deg) by one frame's workt of rotation since frame 0 counts
		xFormHand.SetRotationDegrees(rotationHand);
		pHand->SetXformInfo(xFormHand);

		//clean up and increment the frame number
		pArm = NULL;
		pHand = NULL;
		frame_Equip += ARM_ROTATE_INCREMENT;

	//else if the equip animation is somewhere in the middle of its progress
	} else if (ANIMATION_GO < frame_Equip && frame_Equip < ARM_DISPLACEMENT) {
		//Rotate the arm closer to rest
		UWB_SceneNode* pArm = GetChildNode(1);
		UWB_XformInfo xFormArm = /*GetChildNode(0)*/pArm->GetXformInfo();
		float rotationArm = xFormArm.GetRotationInDegrees();
		xFormArm.SetPivot( vec3(0, 5, 0) ); //hard code, "pivot at armpit"
		rotationArm += ARM_ROTATE_INCREMENT; //rotate the arm a little closer to its resting position
		xFormArm.SetRotationDegrees(rotationArm);
		pArm->SetXformInfo(xFormArm);

		//Rotate the hand closer to rest
		UWB_SceneNode* pHand = pArm->GetChildNode(0);
		UWB_XformInfo xFormHand = pHand->GetXformInfo();
		xFormHand.SetPivot(vec3(8, 6.5, 0)); //hard code, "pivot at palm"
		float rotationHand = xFormHand.GetRotationInDegrees();
		rotationHand += HAND_ROTATE_INCREMENT; //rotate the hand a little closer to its resting position
		xFormHand.SetRotationDegrees(rotationHand);
		pHand->SetXformInfo(xFormHand);

		//clean up and increment the frame number
		pArm = NULL;
		pHand = NULL;
		frame_Equip += ARM_ROTATE_INCREMENT;	

	//else this animation needs to stop
	} else {
		frame_Equip = ANIMATION_READY;
	}
}

void CHuman::AnimationWalk() {
	if(isWalking) {
		UWB_PrimitiveList* pLegs = static_cast<UWB_PrimitiveList*>(GetChildNode(0)->GetPrimitive());
		UWB_PrimitiveRectangleXY* pLeft = static_cast<UWB_PrimitiveRectangleXY*>(pLegs->PrimitiveAt(0));
		UWB_PrimitiveRectangleXY* pRight = static_cast<UWB_PrimitiveRectangleXY*>(pLegs->PrimitiveAt(1));
		vec3 leftCenter = pLeft->GetLocation();
		vec3 rightCenter = pRight->GetLocation();

		UWB_PrimitiveList* pArm = static_cast<UWB_PrimitiveList*>(GetChildNode(2)->GetPrimitive());
		UWB_PrimitiveCircle* pHand = static_cast<UWB_PrimitiveCircle*>(pArm->PrimitiveAt(0));
		vec3 handCenter = pHand->GetLocation();

		frame_Walk += LEG_INCREMENT;
		KeepRadiansInBounds(frame_Walk);

		//Use trig functions to provide oscillating motion
		pLeft->MoveTo(cos(frame_Walk) * LEG_TRAVEL_DISTANCE, leftCenter.y);
		pRight->MoveTo(-cos(frame_Walk) * LEG_TRAVEL_DISTANCE, rightCenter.y);
		pHand->MoveTo(cos(frame_Walk) * LEG_TRAVEL_DISTANCE , handCenter.y); //using the leg travel distance since it's decent

		//Clean up pointers
		pLeft = NULL;
		pRight = NULL;
		pHand = NULL;
	
	//else not walking, so return the legs underneath the body
	} else {
		UWB_PrimitiveList* pLegs = static_cast<UWB_PrimitiveList*>(GetChildNode(0)->GetPrimitive());
		UWB_PrimitiveRectangleXY* pLeft = static_cast<UWB_PrimitiveRectangleXY*>(pLegs->PrimitiveAt(0));
		UWB_PrimitiveRectangleXY* pRight = static_cast<UWB_PrimitiveRectangleXY*>(pLegs->PrimitiveAt(1));
		vec3 leftCenter = pLeft->GetLocation();
		vec3 rightCenter = pRight->GetLocation();

		UWB_PrimitiveList* pArm = static_cast<UWB_PrimitiveList*>(GetChildNode(2)->GetPrimitive());
		UWB_PrimitiveCircle* pHand = static_cast<UWB_PrimitiveCircle*>(pArm->PrimitiveAt(0));
		vec3 handCenter = pHand->GetLocation();

		frame_Walk = UWB_PI / 2; //+= LEG_INCREMENT;
		//KeepRadiansInBounds(frame_Walk);

		//Use trig functions to provide oscillating motion
		pLeft->MoveTo(cos(frame_Walk), leftCenter.y);
		pRight->MoveTo(-cos(frame_Walk), rightCenter.y);
		pHand->MoveTo(cos(frame_Walk), handCenter.y);

		//Clean up
		pLeft = NULL;
		pRight = NULL;
		pHand = NULL;
	}
}
void CHuman::AnimationLook() {
	UWB_SceneNode* pHead = GetChildNode(4);
	UWB_XformInfo xForm = pHead->GetXformInfo();

	frame_Look += LOOK_INCREMENT;
	KeepRadiansInBounds(frame_Look);

	//Use trig functions to provide oscillating motion
	float rotation = cos(frame_Look);
	
	if(-UWB_PI / 4 <= rotation && rotation <= UWB_PI / 4) {
		xForm.SetRotationRadians(rotation);
		pHead->SetXformInfo(xForm);
	}
	
	pHead = NULL;
}

void CHuman::KeepRadiansInBounds(float& rotation) {
	if (rotation < 0) {
		rotation += 2 * UWB_PI;
	} else if (rotation > 2 * UWB_PI) {
		rotation -= 2 * UWB_PI;
	}
}

bool CHuman::IsEquipAnimationActive() {
	return frame_Equip != -1;
}

eEquipmentType CHuman::GetCurrentEquipment() {
	return currentlyHolding;
}

int CHuman::GetInvincibleTimer() const {
	return invincibleTimer;
}

void CHuman::SetInvincibleTimer(int newCount) {
	if(newCount >= 0) {
		invincibleTimer = newCount;
	}
}

UWB_XformInfo CHuman::GetEquipmentXform(UWB_DrawHelper& draw_helper) {
	
	UWB_XformInfo result = UWB_XformInfo(); 	

	UWB_XformInfo handXform = GetChildNode(1)->GetChildNode(0)->GetXformInfo();
	UWB_XformInfo armXform = GetChildNode(1)->GetXformInfo();
	UWB_XformInfo heroXform = m_xform;

	UWB_BoundingBox pEquipmentBounds = GetChildNode(1)->GetChildNode(0)->GetBounds(draw_helper, false);
	vec3 equipmentCenter = pEquipmentBounds.GetCenter();

	draw_helper.PushModelTransform();
	
	//This order is very important!
	heroXform.SetUpModelStack(draw_helper);
	armXform.SetUpModelStack(draw_helper);
	handXform.SetUpModelStack(draw_helper);

	draw_helper.TransformPoint(equipmentCenter);
	result.SetTranslation(equipmentCenter);

	//This seems to get the correct rotation...
	float newRotation = 0.0f;
	newRotation = handXform.GetRotationInRadians() + armXform.GetRotationInRadians() + heroXform.GetRotationInRadians();
	result.SetRotationRadians(newRotation);

	draw_helper.PopModelTransform();
	return result;
}