//Chris Eng & Ken Rice
//CSS450 Sung

//With references from Sung & Baer's CArm class
//Human.h
#pragma once

#define STEP_FORWARD_INCREMENT 1.0f
#define STEP_BACKWARD_INCREMENT 0.5f
#define ROTATION_INCREMENT 5.0f
#define ANIMATION_READY -1
#define ANIMATION_GO 0
#define ARM_DISPLACEMENT 45
#define ARM_ROTATE_INCREMENT 3
#define HAND_ROTATE_INCREMENT 6 //I think this needs to be double of ARM_ROTATE_INCREMENT,
								//since the arm needs to rotate back 45deg, while the hand
								//needs to rotate back 90deg
#define LEG_INCREMENT 0.25f
#define LEG_TRAVEL_DISTANCE 5.0f

#define LOOK_INCREMENT 0.0625f
#define LOOK_TRAVEL_DISTANCE 1.0f

enum eEquipmentType { CELLPHONE, FLASHLIGHT_NORMAL, FLASHLIGHT_HIGH };

class CHuman : public UWB_SceneNode {

public:
	CHuman(const wchar_t* name = L"Human");

	void StepForward();
	void StepBackward();
	void RotateCCW();
	void RotateCW();

	void EquipFlashlight();
	void EquipCellPhone();
	void ToggleFlashlightMode();

	void SetIsWalking(bool flag);

	void Animate();
  
	bool IsEquipAnimationActive();
	eEquipmentType GetCurrentEquipment();

	UWB_XformInfo GetEquipmentXform(UWB_DrawHelper& draw_helper);

	int GetInvincibleTimer() const;
	void SetInvincibleTimer(int newCount);

private:
	
	eEquipmentType currentlyHolding;

	bool isWalking;
	int frame_Equip;
	float frame_Walk; //actually more like radians...;)
	float frame_Look; //also more like radians...

	int invincibleTimer; //if the hero is hit, this elapses the invincibility period

	UWB_PrimitiveRectangleXY* pTool;

	void AnimationEquip();
	void AnimationWalk();
	void AnimationLook();

	void KeepRadiansInBounds(float& rotation);
};