//Chris Eng & Ken Rice
//CSS450 Sung

//LevelOne.cpp

#include "stdafx.h"
#include "LevelOne.h"
#include "EscapeProject.h"

void CLevelOne::Initialize() {
	
	//Initialize all of the component arrays, they are not initialized in CLevel!
	pFloorComponents = new UWB_PrimitiveList();
	pWallComponents = new UWB_PrimitiveList();
	pDoorComponents = new UWB_PrimitiveList();
	pItemComponents = new UWB_PrimitiveList();

	//Initialize all of the size values before making anything!
	m_WorldWidth = m_WorldHeight = 100;
	m_TileRows = 25;
	m_TileCols = 25;
	m_TileHeight = m_WorldHeight / m_TileRows;
	m_TileWidth = m_WorldWidth / m_TileCols;

	//Setup the pseudo-2D array of wall tiles
	m_TileArray = new eTileType[m_TileCols * m_TileRows];
	for(int r = 0; r < m_TileRows; r++) {
		for(int c = 0; c < m_TileCols; c++) {
			m_TileArray[c * m_TileCols + r] = EMPTY;
		}
	}

	//Setup the floor
	UWB_PrimitiveRectangleXY* pFloor = new UWB_PrimitiveRectangleXY();
	pFloor->SetCorners(vec3(0.0f, 0.0f, 0.0f), vec3((float)m_WorldWidth, (float)m_WorldHeight, 0.0f));
	pFloor->SetFlatColor(UWB_Color(100.0f, 0.0f, 0.0f, 1.0f));
	pFloor->SetTextureFileName(L"Texture/StoneFloor.jpg"); //from http://www.sharecg.com/images/medium/4612.jpg
	pFloor->EnableTexturing(true);
	pFloor->EnableBlending(true);
	pFloorComponents->Append(pFloor);

	//wall_0
	MakeWall(vec3(0.0f, 0.0f, 0.0f), vec3(96.0f, 4.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);
	
	//wall_1
	MakeWall(vec3(96.0f, 0.0f, 0.0f), vec3(100.0f, 96.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_2
	MakeWall(vec3(84.0f, 96.0f, 0.0f), vec3(100.0f, 100.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_3
	MakeWall(vec3(4.0f, 96.0f, 0.0f), vec3(76.0f, 100.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_4
	MakeWall(vec3(0.0f, 4.0f, 0.0f), vec3(4.0f, 100.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_5
	MakeWall(vec3(12.0f, 12.0f, 0.0f), vec3(52.0f, 16.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_6
	MakeWall(vec3(52.0f, 12.0f, 0.0f), vec3(56.0f, 96.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_7
	MakeWall(vec3(28.0f, 32.0f, 0.0f), vec3(52.0f, 36.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_8
	MakeWall(vec3(24.0f, 24.0f, 0.0f), vec3(28.0f, 36.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_9
	MakeWall(vec3(12.0f, 16.0f, 0.0f), vec3(16.0f, 36.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_10
	MakeWall(vec3(12.0f, 44.0f, 0.0f), vec3(32.0f, 48.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_11
	MakeWall(vec3(40.0f, 44.0f, 0.0f), vec3(52.0f, 48.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_12
	MakeWall(vec3(24.0f, 60.0f, 0.0f), vec3(44.0f, 64.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_13
	MakeWall(vec3(40.0f, 64.0f, 0.0f), vec3(44.0f, 76.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_14
	MakeWall(vec3(40.0f, 84.0f, 0.0f), vec3(44.0f, 96.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_15
	MakeWall(vec3(12.0f, 48.0f, 0.0f), vec3(16.0f, 76.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_16
	MakeWall(vec3(16.0f, 72.0f, 0.0f), vec3(28.0f, 76.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_17
	MakeWall(vec3(28.0f, 72.0f, 0.0f), vec3(32.0f, 84.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_18
	MakeWall(vec3(4.0f, 84.0f, 0.0f), vec3(32.0f, 88.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_19
	MakeWall(vec3(64.0f, 12.0f, 0.0f), vec3(88.0f, 16.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_20
	MakeWall(vec3(64.0f, 24.0f, 0.0f), vec3(96.0f, 28.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);
	
	//wall_21
	MakeWall(vec3(64.0f, 28.0f, 0.0f), vec3(68.0f, 36.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_22
	MakeWall(vec3(64.0f, 44.0f, 0.0f), vec3(76.0f, 48.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_23
	MakeWall(vec3(76.0f, 36.0f, 0.0f), vec3(80.0f, 60.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_24
	MakeWall(vec3(56.0f, 60.0f, 0.0f), vec3(80.0f, 64.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_25
	MakeWall(vec3(64.0f, 72.0f, 0.0f), vec3(84.0f, 76.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_26
	MakeWall(vec3(84.0f, 72.0f, 0.0f), vec3(88.0f, 96.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//wall_27
	MakeWall(vec3(64.0f, 84.0f, 0.0f), vec3(72.0f, 88.0f, 0.0f), L"Texture/HorizontalWoodWall.bmp");//false, pWallComponents);

	//wall_28
	MakeWall(vec3(72.0f, 84.0f, 0.0f), vec3(76.0f, 96.0f, 0.0f), L"Texture/VerticalWoodWall.bmp");//true, pWallComponents);

	//door_0
	MakeDoor(vec3(32.0f, 4.0f, 0.0f), vec3(36.0f, 12.0f, 0.0f), REDDOOR);
	
	//door_1
	MakeDoor(vec3(64.0f, 36.0f, 0.0f), vec3(68.0f, 44.0f, 0.0f), BLUEDOOR);

	//door_2 //NOTE: EXIT AND DOORS CANNOT BE ON THE SAME TILE!
	MakeDoor(vec3(76.0f, 92.0f, 0.0f), vec3(84.0f, 96.0f, 0.0f), GREENDOOR);

	//item_0 (key_0)
	MakeItem(vec3(6.0f, 90.0f, 0.0f), vec3(10.0f, 94.0f, 0.0f), REDKEY);

	//item_1 (key_1)
	MakeItem(vec3(90.0f, 6.0f, 0.0f), vec3(94.0f, 10.0f, 0.0f), BLUEKEY);

	//item_2 (key_2)
	MakeItem(vec3(90.0f, 90.0f, 0.0f), vec3(94.0f, 94.0f, 0.0f), GREENKEY);

	//This is a bit hackish...:)...but CLevel assumes item ID with placement in ItemComponents...
	MakeItem(vec3(0.0f, 0.0f, 0.0f), vec3(0.0f, 0.0f, 0.0f), YELLOWKEY);

	//item_3 (battery)
	MakeItem(vec3(22.0f, 78.0f, 0.0f), vec3(26.0f, 82.0f, 0.0f), BATTERY);

	//Exit
	MakeExit(vec3(76.0f, 96.0f, 0.0f), vec3(84.0f, 100.0f, 0.0f));

	UWB_PrimitiveList* pAllComponents = new UWB_PrimitiveList();
	pAllComponents->Append(pFloorComponents);
	pAllComponents->Append(pWallComponents);
	pAllComponents->Append(pDoorComponents);
	pAllComponents->Append(pItemComponents);
	SetPrimitive(pAllComponents);

	//Define the level's starting XformInfo
	m_Start_Level.SetScale(vec3(1.75f, 1.75f, 1.0f));
	SetXformInfo(m_Start_Level);

	//Define the hero's starting XformInfo
	m_Start_Hero.SetScale(vec3(0.5f, 0.5f, 1.0f));
	m_Start_Hero.SetTranslation(vec3(14.0f, 14.0f, 0.0f));
	m_Start_Hero.SetRotationRadians(UWB_PI / 2);

	//Define the ghost's starting XformInfo
	m_Start_Ghost.SetScale(m_Start_Hero.GetScale());
	m_Start_Ghost.SetTranslation(vec3(25.0f, 25.0f, 0.0f));	
	m_Start_Ghost.SetRotationRadians(0.0f);

	//Define the blob's starting XformInfo
	m_Start_Blob.SetScale(m_Start_Hero.GetScale());
	m_Start_Blob.SetTranslation(vec3(44.0f, 60.0f, 0.0f));
	m_Start_Blob.SetRotationRadians(0.0f);

	//Define the darkness grid attributes
	//black fog
	m_ShroudColor = UWB_Color(0.0f, 0.0f, 0.0f, 1.0f);

	m_DoorFlag = EMPTY;
}

int CLevelOne::GetLevelNumber() const {
	return 1;
}

bool CLevelOne::DoesLevelHaveBridges() const {
	return false;
}