//Chris Eng & Ken Rice
//CSS450 Sung

//LevelTwo.cpp

#include "stdafx.h"
#include "LevelTwo.h"
#include "EscapeProject.h"

void CLevelTwo::Initialize() {
	//Initialize all of the component arrays, they are not initialized in CLevel!
	pFloorComponents = new UWB_PrimitiveList();
	pWallComponents = new UWB_PrimitiveList();
	pDoorComponents = new UWB_PrimitiveList();
	pItemComponents = new UWB_PrimitiveList();

	//Initialize all of the size values before making anything!
	m_WorldWidth = m_WorldHeight = 100;
	m_TileRows = 25;
	m_TileCols = 25;
	m_TileHeight = m_WorldHeight / m_TileRows;
	m_TileWidth = m_WorldWidth / m_TileCols;

	//Setup the pseudo-2D array of wall tiles
	m_TileArray = new eTileType[m_TileCols * m_TileRows];
	for(int r = 0; r < m_TileRows; r++) {
		for(int c = 0; c < m_TileCols; c++) {
			m_TileArray[c * m_TileCols + r] = EMPTY;
		}
	}

	//Setup the floor
	UWB_PrimitiveRectangleXY* pFloor = new UWB_PrimitiveRectangleXY();
	pFloor->SetCorners(vec3(0.0f, 0.0f, 0.0f), vec3((float)m_WorldWidth, (float)m_WorldHeight, 0.0f));
	pFloor->SetFlatColor(UWB_Color(100.0f, 0.0f, 0.0f, 1.0f));
	pFloor->SetTextureFileName(L"Texture/MarbleFloor.jpg"); //"Grey Marble" by Sue Chastain, http://graphicssoft.about.com/od/freedownloads/ig/125-Free-Seamless-Patterns-/Green-Marble.htm
	pFloor->EnableTexturing(true);
	pFloor->EnableBlending(true);
	pFloorComponents->Append(pFloor);

	//Draw the fancy carpet and stairs near the front door
	DrawStairway();

	//Wall 0
	MakeWall(vec3(0.0f, 0.0f, 0.0f), vec3(44.0f, 4.0f, 0.0f), L"Texture/MohoganyWall.jpg");
	
	//Wall 1
	MakeWall(vec3(56.0f, 0.0f, 0.0f), vec3(96.0f, 4.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 2
	MakeWall(vec3(96.0f, 0.0f, 0.0f), vec3(100.0f, 96.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 3
	MakeWall(vec3(4.0f, 96.0f, 0.0f), vec3(100.0f, 100.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 4
	MakeWall(vec3(0.0f, 4.0f, 0.0f), vec3(4.0f, 100.0f, 0.0f), L"Texture/MohoganyWall.jpg");
	
	//Wall 5
	MakeWall(vec3(12.0f, 4.0f, 0.0f), vec3(16.0f, 16.0f, 0.0f), L"Texture/MohoganyWall.jpg");
	
	//Wall 6
	MakeWall(vec3(24.0f, 12.0f, 0.0f), vec3(28.0f, 16.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 7
	MakeWall(vec3(12.0f, 24.0f, 0.0f), vec3(28.0f, 28.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 8
	MakeWall(vec3(28.0f, 16.0f, 0.0f), vec3(32.0f, 28.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 9
	MakeWall(vec3(32.0f, 16.0f, 0.0f), vec3(44.0f, 20.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 10
	MakeWall(vec3(36.0f, 4.0f, 0.0f), vec3(40.0f, 16.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 11
	MakeWall(vec3(56.0f, 16.0f, 0.0f), vec3(68.0f, 20.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 12
	MakeWall(vec3(60.0f, 4.0f, 0.0f), vec3(64.0f, 16.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 13
	MakeWall(vec3(68.0f, 16.0f, 0.0f), vec3(72.0f, 28.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 14
	MakeWall(vec3(80.0f, 28.0f, 0.0f), vec3(84.0f, 36.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 15
	MakeWall(vec3(80.0f, 24.0f, 0.0f), vec3(88.0f, 28.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 16
	MakeWall(vec3(80.0f, 12.0f, 0.0f), vec3(88.0f, 16.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 17
	MakeWall(vec3(80.0f, 4.0f, 0.0f), vec3(84.0f, 12.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 18
	MakeWall(vec3(4.0f, 36.0f, 0.0f), vec3(16.0f, 40.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 19
	MakeWall(vec3(12.0f, 40.0f, 0.0f), vec3(16.0f, 48.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 20
	MakeWall(vec3(12.0f, 48.0f, 0.0f), vec3(20.0f, 52.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 21
	MakeWall(vec3(24.0f, 36.0f, 0.0f), vec3(40.0f, 40.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 22
	MakeWall(vec3(40.0f, 32.0f, 0.0f), vec3(44.0f, 52.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 23
	MakeWall(vec3(56.0f, 32.0f, 0.0f), vec3(60.0f, 52.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 24
	MakeWall(vec3(60.0f, 36.0f, 0.0f), vec3(96.0f, 40.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 25
	MakeWall(vec3(12.0f, 64.0f, 0.0f), vec3(16.0f, 84.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 26
	MakeWall(vec3(12.0f, 60.0f, 0.0f), vec3(32.0f, 64.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 27
	MakeWall(vec3(28.0f, 40.0f, 0.0f), vec3(32.0f, 60.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 28
	MakeWall(vec3(24.0f, 72.0f, 0.0f), vec3(60.0f, 76.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 29
	MakeWall(vec3(40.0f, 60.0f, 0.0f), vec3(44.0f, 72.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 30
	MakeWall(vec3(12.0f, 84.0f, 0.0f), vec3(88.0f, 88.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 31
	MakeWall(vec3(56.0f, 60.0f, 0.0f), vec3(60.0f, 72.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 32
	MakeWall(vec3(60.0f, 60.0f, 0.0f), vec3(88.0f, 64.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 33
	MakeWall(vec3(68.0f, 72.0f, 0.0f), vec3(76.0f, 76.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 34
	MakeWall(vec3(72.0f, 64.0f, 0.0f), vec3(76.0f, 72.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 35
	MakeWall(vec3(84.0f, 64.0f, 0.0f), vec3(88.0f, 84.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 36
	MakeWall(vec3(68.0f, 40.0f, 0.0f), vec3(72.0f, 60.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Wall 37
	MakeWall(vec3(80.0f, 48.0f, 0.0f), vec3(88.0f, 52.0f, 0.0f), L"Texture/MohoganyWall.jpg");

	//Red door
	MakeDoor(vec3(68.0f, 28.0f, 0.0f), vec3(72.0f, 36.0f, 0.0f), REDDOOR);

	//Green door
	MakeDoor(vec3(32.0f, 60.0f, 0.0f), vec3(40.0f, 64.0f, .0f), GREENDOOR);

	//Blue door
	MakeDoor(vec3(44.0f, 16.0f, .0f), vec3(56.0f, 20.0f, .0f), BLUEDOOR);

	//Yellow door
	MakeDoor(vec3(44.0f, 60.0f, 0.0f), vec3(56.0f, 64.0f, .0f), YELLOWDOOR);
	
	//Red key
	MakeItem(vec3(74.0f, 42.0f, 0.0f), vec3(78.0f, 46.0f, 0.0f), REDKEY);

	//Blue key
	MakeItem(vec3(66.0f, 66.0f, 0.0f), vec3(70.0f, 70.0f, 0.0f), BLUEKEY);
		
	//Green key
	MakeItem(vec3(86.0f, 6.0f, 0.0f), vec3(90.0f, 10.0f, 0.0f), GREENKEY);

	//Yellow key
	MakeItem(vec3(30.0f, 10.0f, 0.0f), vec3(34.0f, 14.0f, 0.0f), YELLOWKEY);

	//Battery
	MakeItem(vec3(48.0f, 64.0f, 0.0f), vec3(52.0f, 68.0f, 0.0f), BATTERY);

	//Exit
	MakeExit(vec3(44.0f, 0.0f, 0.0f), vec3(56.0f, 4.0f, 0.0f));

	//Add the components to this level's Primitive pointer
	UWB_PrimitiveList* pAllComponents = new UWB_PrimitiveList();
	pAllComponents->Append(pFloorComponents);
	pAllComponents->Append(pWallComponents);
	pAllComponents->Append(pDoorComponents);
	pAllComponents->Append(pItemComponents);
	SetPrimitive(pAllComponents);

	//Define the level's starting XformInfo
	m_Start_Level.SetScale(vec3(1.75f, 1.75f, 1.0f));
	SetXformInfo(m_Start_Level);

	//Define the hero's starting XformInfo
	m_Start_Hero.SetScale(vec3(0.5f, 0.5f, 1.0f));
	m_Start_Hero.SetTranslation(vec3(28.0f * GetXformInfo().GetScale().x, 92.0f * GetXformInfo().GetScale().y, 0.0f));
	m_Start_Hero.SetRotationRadians(3 * UWB_PI / 2);

	//Define the ghost's starting XformInfo
	m_Start_Ghost.SetScale(m_Start_Hero.GetScale());
	m_Start_Ghost.SetTranslation(vec3(25.0f, 25.0f, 0.0f));
	m_Start_Ghost.SetRotationRadians(0.0f);

	//Define the blob's starting XformInfo
	m_Start_Blob.SetScale(m_Start_Hero.GetScale());
	m_Start_Blob.SetTranslation(vec3(14.0f, 30.0f, 0.0f));
	m_Start_Blob.SetRotationRadians(0.0f);

	//Define the shroud grid attributes
	m_ShroudColor = UWB_Color(0.0f, 0.0f, 0.0f, 1.0f);

	m_DoorFlag = EMPTY;
}

int CLevelTwo::GetLevelNumber() const {
	return 2;
}

bool CLevelTwo::DoesLevelHaveBridges() const {
	return false;
}

void CLevelTwo::DrawStairway() {

	//Draw the half-circle at the foot of the stairs
	CWedge* pCC1 = new CWedge(UWB_PI, UWB_PI / 2);
	pCC1->SetCenter(50.0f, 32.0f, 0.0f);
	pCC1->SetRadius(10.0f);
	pCC1->SetFlatColor(UWB_Color(0.9f, 0.7f, 0.0f, 1.0f));
	pCC1->SetShadeMode( smFlat );
	pFloorComponents->Append(pCC1);

	CWedge* pCC2 = new CWedge(UWB_PI, UWB_PI / 2);
	pCC2->SetCenter(50.0f, 31.5f, 0.0f);
	pCC2->SetRadius(9.25f);
	pCC2->SetFlatColor(UWB_Color(0.3f, 0.1f, 0.0f, 1.0f));
	pCC2->SetShadeMode( smFlat );
	pFloorComponents->Append(pCC2);

	//Draw the carpet at the top of the stairs
	UWB_PrimitiveRectangleXY* pTC1 = new UWB_PrimitiveRectangleXY();
	pTC1->SetCorners(vec3(34.0f, 54.0f, 0.0f), vec3(66.0f, 58.0f, 0.0f));
	pTC1->SetFlatColor(UWB_Color(0.9f, 0.7f, 0.0f, 1.0f));
	pTC1->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC1);

	UWB_PrimitiveRectangleXY* pTC2 = new UWB_PrimitiveRectangleXY();
	pTC2->SetCorners(vec3(34.0f, 42.0f, 0.0f), vec3(38.0f, 58.0f, 0.0f));
	pTC2->SetFlatColor(UWB_Color(0.9f, 0.7f, 0.0f, 1.0f));
	pTC2->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC2);

	UWB_PrimitiveRectangleXY* pTC3 = new UWB_PrimitiveRectangleXY();
	pTC3->SetCorners(vec3(62.0f, 42.0f, 0.0f), vec3(66.0f, 58.0f, 0.0f));
	pTC3->SetFlatColor(UWB_Color(0.9f, 0.7f, 0.0f, 1.0f));
	pTC3->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC3);

	UWB_PrimitiveRectangleXY* pTC4 = new UWB_PrimitiveRectangleXY();
	pTC4->SetCorners(vec3(34.25f, 54.25f, 0.0f), vec3(65.75f, 57.75f, 0.0f));
	pTC4->SetFlatColor(UWB_Color(0.3f, 0.1f, 0.0f, 1.0f));
	pTC4->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC4);

	UWB_PrimitiveRectangleXY* pTC5 = new UWB_PrimitiveRectangleXY();
	pTC5->SetCorners(vec3(34.25f, 42.25f, 0.0f), vec3(37.75f, 57.75f, 0.0f));
	pTC5->SetFlatColor(UWB_Color(0.3f, 0.1f, 0.0f, 1.0f));
	pTC5->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC5);

	UWB_PrimitiveRectangleXY* pTC6 = new UWB_PrimitiveRectangleXY();
	pTC6->SetCorners(vec3(62.25f, 42.25f, 0.0f), vec3(65.75f, 57.75f, 0.0f));
	pTC6->SetFlatColor(UWB_Color(0.3f, 0.1f, 0.0f, 1.0f));
	pTC6->SetShadeMode( smFlat );
	pFloorComponents->Append(pTC6);

	//Draw the carpet on the stairs
	UWB_PrimitiveRectangleXY* pSC1 = new UWB_PrimitiveRectangleXY();
	pSC1->SetCorners(vec3(46.0f, 32.0f, 0.0f), vec3(54.0f, 54.0f, 0.0f));
	pSC1->SetFlatColor(UWB_Color(0.9f, 0.7f, 0.0f, 1.0f));
	pSC1->SetShadeMode( smFlat );
	pFloorComponents->Append(pSC1);
	
	UWB_PrimitiveRectangleXY* pSC2 = new UWB_PrimitiveRectangleXY();
	pSC2->SetCorners(vec3(46.25f, 30.0f, 0.0f), vec3(53.75f, 56.0f, 0.0f));
	pSC2->SetFlatColor(UWB_Color(0.3f, 0.1f, 0.0f, 1.0f));
	pSC2->SetShadeMode( smFlat );
	pFloorComponents->Append(pSC2);

	//Draw the stairs
	float constLeftX = 44.0f;
	float constRightX = 56.0f;
	for(float y = 32; y <= 52; y += 2) {
		UWB_PrimitiveLine* pStair = new UWB_PrimitiveLine();
		pStair->SetStartPoint(constLeftX, y, 0.0f);
		pStair->SetEndPoint(constRightX, y, 0.0f);
		pStair->SetFlatColor(UWB_Color(0.5f, 0.5f, 0.5f, 1.0f));
		pStair->SetShadeMode( smFlat );
		pFloorComponents->Append(pStair);
	}
}