//Chris Eng & Ken Rice
//CSS450 Sung

// OptionDialog.cpp : implementation file
//

#include "stdafx.h"
#include "EscapeProject.h"
#include "OptionDialog.h"


// OptionDialog dialog

IMPLEMENT_DYNAMIC(COptionDialog, CDialog)

COptionDialog::COptionDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDialog::IDD, pParent)
	, m_MonsterAttackString(_T(""))
	, m_MonsterSpeedString(_T(""))
	, m_MonsterStunString(_T(""))
	, m_BatteryLifeString(_T(""))
	, m_HeroInvincibilityString(_T(""))
	, m_CarryoverString(_T(""))
{
	
}

COptionDialog::~COptionDialog()
{
}

void COptionDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_DIFFICULTY, m_SliderDifficulty);
	DDX_Text(pDX, IDC_ECHO_MONSTER_ATTACK, m_MonsterAttackString);
	DDX_Text(pDX, IDC_ECHO_MONSTER_SPEED, m_MonsterSpeedString);
	DDX_Text(pDX, IDC_ECHO_MONSTER_STUN, m_MonsterStunString);
	DDX_Text(pDX, IDC_ECHO_BATTERY_OPTIONSDLG, m_BatteryLifeString);
	DDX_Text(pDX, IDC_ECHO_HERO_INVINCIBILITY, m_HeroInvincibilityString);
	DDX_Text(pDX, IDC_ECHO_HERO_LIFE_CARRYOVER, m_CarryoverString);
}


BEGIN_MESSAGE_MAP(COptionDialog, CDialog)
	ON_BN_CLICKED(IDOK, &COptionDialog::OnBnClickedOk)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

BOOL COptionDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_difficulty = theApp.GetModel().GetWaitingDifficulty();
	m_SliderDifficulty.Initialize(0.5f, 1.5f, m_difficulty);
	SetDifficultyStrings();	

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// OptionDialog message handlers

void COptionDialog::OnBnClickedOk()
{
	theApp.GetModel().SetWaitingDifficulty(m_difficulty);
	OnOK();
}

void COptionDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(pScrollBar == (CScrollBar *) & m_SliderDifficulty)
	{
		float value = m_SliderDifficulty.GetSliderValue();
		m_difficulty = value;
		m_SliderDifficulty.SetSliderValue(value);
		SetDifficultyStrings();	
	}
	else
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COptionDialog::SetDifficultyStrings() {

	if(m_difficulty <= 0.75f)
	{
		m_MonsterAttackString = "Weak";
		m_MonsterSpeedString = "Slow";
		m_MonsterStunString = "Long";
		m_BatteryLifeString = "Long";
		m_HeroInvincibilityString = "Long";
		m_CarryoverString = "High";
	}
	else if (m_difficulty > 0.75f && m_difficulty < 1.25f)
	{
		m_MonsterAttackString = "Average";
		m_MonsterSpeedString = "Average";
		m_MonsterStunString = "Average";
		m_BatteryLifeString = "Average";
		m_HeroInvincibilityString = "Average";
		m_CarryoverString = "Average";
	}
	else if(m_difficulty >= 1.25f)
	{
		m_MonsterAttackString = "Strong";
		m_MonsterSpeedString = "Fast";
		m_MonsterStunString = "Short";
		m_BatteryLifeString = "Short";
		m_HeroInvincibilityString = "Short";
		m_CarryoverString = "Low";
	}
	UpdateData(false);
}
