// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DDefines.h"
#include "uwbgl_DrawHelper2.h"

//EDITS BY CHRIS

// Direct3D specific implementation of the DrawHelper class.
class UWBD3D_DrawHelper : public UWB_DrawHelper
{
public:
  UWBD3D_DrawHelper();
  virtual ~UWBD3D_DrawHelper();

  // virtual function overrides
  bool DrawPoint( vec3 position );
  bool DrawLine(vec3 start, vec3 end);
  bool DrawCircle( vec3 center, float radius);
  bool DrawRectangleXY( vec3 corner1, vec3 corner2);

  //Chris' Special
  bool DrawWedge(vec3 center, float radius, float wedgeGap, float rotationRad);

  bool EnableBlending( bool on );
  bool EnableTexture(bool on);
  void SetShadeMode( eShadeMode mode );
  void SetFillMode( eFillMode mode );

  bool AccumulateModelTransform( vec3 translation,
                          vec3 scale,
                          float rotation_radians,
                          vec3 pivot );
  bool PushModelTransform();
  bool PopModelTransform();
  bool InitializeModelTransform();
  bool TransformPoint(vec3& point);

private:
  ID3DXMatrixStack* m_pMatrixStack;
};
