// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DDefines.h"
#include <string>

/// A Direct3D resource (either mesh or texture) that is loaded into and
/// maintained by the Direct3D API. This class serves as a connection to
/// a specific Direct3D resource
class UWBD3D_Resource
{
public:
  UWBD3D_Resource();
  virtual ~UWBD3D_Resource();

  /// resources typically are defined by their name. In many cases, the
  /// name matches a filename that a resource is loaded from
  const wchar_t* GetResourceName() const;

  virtual bool LoadResource(LPDIRECT3DDEVICE9, const wchar_t* fileName);
  
protected:

  virtual void  ReleaseMemory();
  virtual bool  LoadResourceFromFile(const wchar_t* fullPathName) = 0;

  void FindFilePath(const wchar_t* filename, std::wstring& fullPath);
  
  LPDIRECT3DDEVICE9             m_pDevice;       // Which device will store this mesh
  std::wstring                  m_ResourceName;
};
