#include "uwbgl_DrawHelper2.h"

UWB_DrawHelper::UWB_DrawHelper()
: m_lod(lodHigh)
, m_ShadeMode(smGouraud)
, m_FillMode(fmSolid)
{
  ResetAttributes();
}

UWB_DrawHelper::~UWB_DrawHelper()
{
}

void UWB_DrawHelper::SetLOD(eLevelOfDetail lod)
{
  m_lod = lod;
}

eLevelOfDetail UWB_DrawHelper::GetLOD() const
{
  return m_lod;
}

void UWB_DrawHelper::ResetAttributes()
{
  m_PointSize = 1.0f;
  m_Color1 = UWB_NOCOLOR;
  m_Color2 = UWB_NOCOLOR;
  EnableBlending(false);
  EnableTexture(false);
}

void UWB_DrawHelper::SetShadeMode( eShadeMode mode )
{
  m_ShadeMode = mode;
}

eShadeMode UWB_DrawHelper::GetShadeMode() const
{
  return m_ShadeMode;
}

void UWB_DrawHelper::SetFillMode( eFillMode mode )
{
  m_FillMode = mode;
}

eFillMode UWB_DrawHelper::GetFillMode() const
{
  return m_FillMode;
}

UWB_Color UWB_DrawHelper::SetColor1( UWB_Color color )
{
  UWB_Color old = m_Color1;
  m_Color1 = color;
  return old;
}

UWB_Color UWB_DrawHelper::SetColor2( UWB_Color color )
{
  UWB_Color old = m_Color2;
  m_Color2 = color;
  return old;
}

float UWB_DrawHelper::SetPointSize( float pt_size )
{
  float old = m_PointSize;
  m_PointSize = pt_size;
  return old;
}

void UWB_DrawHelper::SetTextureInfo(const wchar_t* texFile)
{
  m_TexFileName = texFile;
}