#include "uwbgl_XformInfo2.h"

UWB_XformInfo::UWB_XformInfo()
: m_pivot(0,0,0)
{
  ToIdentity();
}

void UWB_XformInfo::SetUpModelStack(UWB_DrawHelper& draw_helper) const
{
  draw_helper.AccumulateModelTransform( m_translation, m_scale, m_rotation_radians, m_pivot );
}

void UWB_XformInfo::ToIdentity()
{
  m_translation = vec3(0.0f,0.0f,0.0f);
  m_scale = vec3(1.0f,1.0f,1.0f);
  m_rotation_radians = 0;
  // pivot is not set
}

void UWB_XformInfo::DrawPivot(UWB_DrawHelper &h, float size) const
{
  h.ResetAttributes();
  h.SetColor1(UWB_Color(1.0f, 1.0f, 1.0f) );
  h.SetColor2(UWB_Color(0.0f, 0.0f, 1.0f) );
  h.SetFillMode( fmSolid );
  h.SetShadeMode( smGouraud );
  h.DrawCircle( m_pivot, size);
}

vec3 UWB_XformInfo::GetTranslation() const{ return m_translation; }
void UWB_XformInfo::SetTranslation(vec3 translation){ m_translation = translation; }

vec3 UWB_XformInfo::GetScale() const {return m_scale;}
void UWB_XformInfo::SetScale(vec3 scale) { m_scale = scale; }

float UWB_XformInfo::GetRotationInRadians() const { return m_rotation_radians;}
float UWB_XformInfo::GetRotationInDegrees() const { return UWB_ToDegrees(m_rotation_radians); }
void UWB_XformInfo::SetRotationRadians(float angle_in_radians) { m_rotation_radians = angle_in_radians; }
void UWB_XformInfo::SetRotationDegrees(float angle_in_degrees) { m_rotation_radians = UWB_ToRadians(angle_in_degrees); }

vec3 UWB_XformInfo::GetPivot() const {return m_pivot;}
void UWB_XformInfo::SetPivot(vec3 pivot) {m_pivot = pivot;}